﻿Imports System.Data

Partial Class Analisis_EfectividadEmpadres
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not (Page.IsPostBack) Then
            ConsultarAños()
        End If

        Dim anio As String, Sexo As String, Estatus As String
        anio = ddlAnoEmp.SelectedValue
        Sexo = ddlSexoAnimal.SelectedValue
        Estatus = ddlEstatus.SelectedValue
        ConsultarExectividad(anio, Sexo, Estatus)
    End Sub



    'Se Consultan los años de los empadres registrados
    Public Sub ConsultarAños()
        Dim sUsuario As String = String.Empty
        sUsuario = Membership.GetUser().UserName

        Dim sdsPantallas As New SqlDataSource
        Dim sSQL As String = "select top 10 ano from dbo.empadre group by ano order by ano desc;"
        Dim Resultado As Boolean = False
        Try
            sdsPantallas = New SqlDataSource
            sdsPantallas.ConnectionString = ConfigurationManager.ConnectionStrings("GanaderiaConnectionString").ConnectionString
            sdsPantallas.SelectCommand = sSQL

            Dim view As DataView = sdsPantallas.Select(New DataSourceSelectArguments())
            Dim groupsTable As DataTable = view.ToTable()
            ddlAnoEmp.DataSource = groupsTable
            ddlAnoEmp.DataBind()           
        Catch ex As Exception
        End Try
    End Sub

    Protected Sub btnProcesar_Click(sender As Object, e As EventArgs) Handles btnProcesar.Click
        Dim anio As String, Sexo As String, Estatus As String
        anio = ddlAnoEmp.SelectedValue
        Sexo = ddlSexoAnimal.SelectedValue
        Estatus = ddlEstatus.SelectedValue
        ConsultarExectividad(anio, Sexo, Estatus)
    End Sub


    Public Sub ConsultarExectividad(ByVal pAnio As String, ByVal pSexo As String, ByVal pEstatus As String)
        Dim sUsuario As String = String.Empty
        sUsuario = Membership.GetUser().UserName

        Dim sSQL As String
        Dim strHeaderListado As String = "", strHeaderAnio As String = "Año", strHeadercrias As String = "Crías"
        'Dim lstAnios As New List(Of String)
        'lstAnios.Add(pAnio)

        'If (chkTodoAnos.Checked) Then
        '    For Each item As ListItem In ddlAnoEmp.Items
        '        lstAnios.Add(item.Value)
        '    Next
        'End If
        'pAnio = String.Empty
        'For Each s In lstAnios
        '    pAnio &= s & ","
        'Next
        'pAnio = pAnio.Remove(pAnio.Length - 1)



        'If (pEstatus = "V") Then
        '    strEstatus = " NULL "
        'Else
        '    strEstatus = " NOT NULL "
        'End If

        'If (chkTodosEstatus.Checked) Then
        '    strEstatus = " NULL OR FECHABAJA IS NOT NULL "
        'End If

        'Dim strRepaso As String = " IS NULL "
        ''If (chkRepaso.Checked) Then
        ''    strRepaso = " IS NOT NULL "
        ''End If

        'Dim anioSeleccionado As Integer = ddlAnoEmp.SelectedValue
        'anioSeleccionado += 1
        ' If (pSexo = "T") Then
        'strHeaderListado = "Total de Vacas"

        'If (chkTodoAnos.Checked) Then
        '    strAnios = lstAnios(lstAnios.Count - 1).ToString & "-" & lstAnios(0).ToString
        '    strHeaderAnio = "Años"
        '    sSQL = "select " & _
        '    "Toros.toro animal" & _
        '    ",Toros.toroId AnimalId" & _
        '    ",Toros.nombre " & _
        '    ",'" & strAnios & "' ano " & _
        '    ",COUNT(Vacas.vacaID)  Total_Empadres" & _
        '    ",COUNT(Hijos.Id_Hijo) Total_Crias			" & _
        '    ",ROUND(CAST((CONVERT(DECIMAL,COUNT(Hijos.Id_Hijo))/CONVERT(DECIMAL,COUNT(Vacas.vacaID))*100) AS DECIMAL(10,0)),0) AS Efectividad " & _
        '    "from dbo.Emp_Movs Vacas " & _
        '    "inner join dbo.empadre Toros on Vacas.empadreId=Toros.empadreId " & _
        '    "left outer join (select   madre.AnimalId Id_Madre				 " & _
        '    "						,hijo.AnimalId  Id_Hijo" & _
        '    "						,hijo.fechanac		" & _
        '    "						,DATEADD(day,-270,hijo.fechanac) fecaprox_empadre_270" & _
        '    "						,DATEADD(day,-275,hijo.fechanac) fecaprox_empadre" & _
        '    "						,DATEADD(day,-280,hijo.fechanac) fecaprox_empadre_280" & _
        '    "						,YEAR(DATEADD(day,-275,hijo.fechanac)) anio_empadre" & _
        '    "				from dbo.animal madre " & _
        '    "				LEFT OUTER join dbo.animal hijo on madre.AnimalId=hijo.id_madre" & _
        '    "				WHERE hijo.AnimalId is not null) Hijos " & _
        '    "On Vacas.vacaID=Hijos.Id_Madre " & _
        '    "AND (Hijos.fecaprox_empadre_270 BETWEEN Vacas.fechaini AND Vacas.fechafin OR Hijos.fecaprox_empadre BETWEEN Vacas.fechaini AND Vacas.fechafin OR Hijos.fecaprox_empadre_280 BETWEEN Vacas.fechaini AND Vacas.fechafin)	" & _
        '    "WHERE Toros.ano IN(" & pAnio & ") " & _
        '    "AND Toros.toroId IN(select AnimalId from dbo.animal where  FECHABAJA IS" & strEstatus & ") "
        '    'sSQL = sSQL & "AND  Toros.Repaso " & strRepaso
        '    sSQL = sSQL & "group by Toros.toro ,Toros.toroId,Toros.nombre " & _
        '    "order by  Efectividad DESC;"
        'Else
        '    strHeadercrias = "Crías(" & anioSeleccionado.ToString & ")"
        '    sSQL = "select " & _
        '    "Toros.toro animal" & _
        '    ",Toros.toroId AnimalId" & _
        '    ",Toros.nombre " & _
        '    ",Toros.ano	" & _
        '    ",COUNT(Vacas.vacaID)  Total_Empadres" & _
        '    ",COUNT(Hijos.Id_Hijo) Total_Crias			" & _
        '    ",ROUND(CAST((CONVERT(DECIMAL,COUNT(Hijos.Id_Hijo))/CONVERT(DECIMAL,COUNT(Vacas.vacaID))*100) AS DECIMAL(10,0)),0) AS Efectividad " & _
        '    "from dbo.Emp_Movs Vacas " & _
        '    "inner join dbo.empadre Toros on Vacas.empadreId=Toros.empadreId " & _
        '    "left outer join (select   madre.AnimalId Id_Madre				 " & _
        '    "						,hijo.AnimalId  Id_Hijo" & _
        '    "						,hijo.fechanac		" & _
        '    "						,DATEADD(day,-270,hijo.fechanac) fecaprox_empadre_270" & _
        '    "						,DATEADD(day,-275,hijo.fechanac) fecaprox_empadre" & _
        '    "						,DATEADD(day,-280,hijo.fechanac) fecaprox_empadre_280" & _
        '    "						,YEAR(DATEADD(day,-275,hijo.fechanac)) anio_empadre" & _
        '    "				from dbo.animal madre " & _
        '    "				LEFT OUTER join dbo.animal hijo on madre.AnimalId=hijo.id_madre" & _
        '    "				WHERE hijo.AnimalId is not null) Hijos " & _
        '    "On Vacas.vacaID=Hijos.Id_Madre " & _
        '    "AND (Hijos.fecaprox_empadre_270 BETWEEN Vacas.fechaini AND Vacas.fechafin OR Hijos.fecaprox_empadre BETWEEN Vacas.fechaini AND Vacas.fechafin OR Hijos.fecaprox_empadre_280 BETWEEN Vacas.fechaini AND Vacas.fechafin)	" & _
        '    "WHERE Toros.ano IN(" & pAnio & ") " & _
        '    "AND Toros.toroId IN(select AnimalId from dbo.animal where  FECHABAJA IS" & strEstatus & ") "
        '    'sSQL = sSQL & "AND  Toros.Repaso " & strRepaso
        '    sSQL = sSQL & "group by Toros.toro ,Toros.toroId,Toros.nombre,Toros.Ubicacion,Toros.ano " & _
        '    "order by Efectividad DESC;"
        'End If

        'Else
        'strHeaderListado = "Total de Toros"
        'If (chkTodoAnos.Checked) Then
        '    strAnios = lstAnios(lstAnios.Count - 1).ToString & "-" & lstAnios(0).ToString
        '    strHeaderAnio = "Años"
        '    sSQL = " select 		" & _
        '    "		Vacas.vaca Animal" & _
        '    "		,Vacas.vacaID AnimalId" & _
        '    "		,Vacas.nombre	" & _
        '    "		,'" & strAnios & "' ano " & _
        '    "		,COUNT(Vacas.vaca) 'Total_Empadres' " & _
        '    "		,COUNT(Hijos.Id_Hijo) 'Total_Crias' " & _
        '    ",ROUND(CAST((CONVERT(DECIMAL,COUNT(Hijos.Id_Hijo))/CONVERT(DECIMAL,COUNT(Vacas.vaca))*100) AS DECIMAL(10,0)),0) AS  Efectividad " & _
        '    " from dbo.Emp_Movs Vacas  " & _
        '    " left outer join (select   madre.AnimalId Id_Madre				 " & _
        '    "							,hijo.AnimalId  Id_Hijo " & _
        '    "							,hijo.fechanac	 " & _
        '    "							,DATEADD(day,-270,hijo.fechanac) fecaprox_empadre_270	" & _
        '    "							,DATEADD(day,-275,hijo.fechanac) fecaprox_empadre " & _
        '    "							,DATEADD(day,-280,hijo.fechanac) fecaprox_empadre_280 " & _
        '    "							,YEAR(DATEADD(day,-275,hijo.fechanac)) anio_empadre " & _
        '    "					from dbo.animal madre " & _
        '    "					LEFT OUTER join dbo.animal hijo on madre.AnimalId=hijo.id_madre " & _
        '    "					WHERE hijo.AnimalId is not null) Hijos " & _
        '    "On Vacas.vacaID=Hijos.Id_Madre  " & _
        '    "AND (Hijos.fecaprox_empadre_270 BETWEEN Vacas.fechaini AND Vacas.fechafin OR Hijos.fecaprox_empadre BETWEEN Vacas.fechaini AND Vacas.fechafin OR " & _
        '    "Hijos.fecaprox_empadre_280 BETWEEN Vacas.fechaini AND Vacas.fechafin) " & _
        '    "where Vacas.ano IN(" & pAnio & ") " & _
        '    "AND Vacas.vacaID IN(select AnimalId from dbo.animal where  FECHABAJA IS" & strEstatus & ") " & _
        '    "group by Vacas.vaca ,Vacas.vacaID ,Vacas.nombre " & _
        '    "order by Efectividad DESC;"
        'Else
        '    strHeadercrias = "Crías(" & anioSeleccionado.ToString & ")"
        '    sSQL = " select 		" & _
        '    "		Vacas.vaca Animal" & _
        '    "		,Vacas.vacaID AnimalId" & _
        '    "		,Vacas.nombre	" & _
        '    "		,Vacas.ano		" & _
        '    "		,COUNT(Vacas.vaca) 'Total_Empadres' " & _
        '    "		,COUNT(Hijos.Id_Hijo) 'Total_Crias' " & _
        '    ",ROUND(CAST((CONVERT(DECIMAL,COUNT(Hijos.Id_Hijo))/CONVERT(DECIMAL,COUNT(Vacas.vaca))*100) AS DECIMAL(10,0)),0) AS  Efectividad " & _
        '    " from dbo.Emp_Movs Vacas  " & _
        '    " left outer join (select   madre.AnimalId Id_Madre				 " & _
        '    "							,hijo.AnimalId  Id_Hijo " & _
        '    "							,hijo.fechanac	 " & _
        '    "							,DATEADD(day,-270,hijo.fechanac) fecaprox_empadre_270	" & _
        '    "							,DATEADD(day,-275,hijo.fechanac) fecaprox_empadre " & _
        '    "							,DATEADD(day,-280,hijo.fechanac) fecaprox_empadre_280 " & _
        '    "							,YEAR(DATEADD(day,-275,hijo.fechanac)) anio_empadre " & _
        '    "					from dbo.animal madre " & _
        '    "					LEFT OUTER join dbo.animal hijo on madre.AnimalId=hijo.id_madre " & _
        '    "					WHERE hijo.AnimalId is not null) Hijos " & _
        '    "On Vacas.vacaID=Hijos.Id_Madre  " & _
        '    "AND (Hijos.fecaprox_empadre_270 BETWEEN Vacas.fechaini AND Vacas.fechafin OR Hijos.fecaprox_empadre BETWEEN Vacas.fechaini AND Vacas.fechafin OR " & _
        '    "Hijos.fecaprox_empadre_280 BETWEEN Vacas.fechaini AND Vacas.fechafin) " & _
        '    "where Vacas.ano IN(" & pAnio & ") " & _
        '    "AND Vacas.vacaID IN(select AnimalId from dbo.animal where  FECHABAJA IS" & strEstatus & ") " & _
        '    "group by Vacas.vaca ,Vacas.vacaID ,Vacas.nombre ,Vacas.ano " & _
        '    "order by Efectividad DESC;"
        'End If
        'End If

        Select Case (pSexo)
            Case "T"
                strHeaderListado = "Total de Vacas"
            Case "V"
                strHeaderListado = "Total de Toros"
        End Select
        Dim pANIOS As String = "0", strEstatus As String

        If (chkTodoAnos.Checked) Then
            pANIOS = "1"
        End If

        If (pEstatus = "V") Then
            strEstatus = "1"
        Else
            strEstatus = "2"
        End If
        If (chkTodosEstatus.Checked) Then
            strEstatus = "0"
        End If



        sSQL = "EXEC dbo.ConsultarEfectividad '" & pSexo & "'," & _
                                                   strEstatus.ToString() & "," & _
                                                   pAnio.ToString() & "," & _
                                                   pANIOS.ToString() & ";"
        Dim Resultado As Boolean = False
        Try
            sqlGeneral.SelectCommand = sSQL
            grvEmpadres.DataBind()

            'Cambiar Header del grid
            Dim Column As New DataControlFieldCollection
            Column = grvEmpadres.Columns
            Column(2).HeaderText = strHeaderAnio
            Column(3).HeaderText = strHeaderListado
            Column(4).HeaderText = strHeadercrias

        Catch ex As Exception

        End Try

        divGrid.Visible = True
    End Sub

    Protected Sub chkTodoAnos_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles chkTodoAnos.CheckedChanged
        If chkTodoAnos.Checked Then
            ddlAnoEmp.Enabled = False
        Else
            ddlAnoEmp.Enabled = True
        End If
    End Sub

    Protected Sub chkTodosEstatus_CheckedChanged(sender As Object, e As EventArgs) Handles chkTodosEstatus.CheckedChanged
        If chkTodosEstatus.Checked Then
            ddlEstatus.Enabled = False
        Else
            ddlEstatus.Enabled = True
        End If
    End Sub
End Class
