﻿Imports Microsoft.VisualBasic
Public Class AddTemplateToGridView
    Implements ITemplate
    Private _type As ListItemType
    Private _colName As String
    Private _control As String
    Private _evt As EventArgs
    Public Sub New(type As ListItemType, colname As String, control As String)
        _type = type
        _colName = colname
        _control = control
    End Sub
    Private Sub ITemplate_InstantiateIn(container As System.Web.UI.Control) Implements ITemplate.InstantiateIn

        Select Case _type
            Case ListItemType.Item

                Select Case _control
                    Case "txt"
                        Dim txt As New TextBox
                        txt.MaxLength = 10
                        txt.Width = 70
                        txt.ID = _colName
                        AddHandler txt.DataBinding, AddressOf OnDataBinding
                        container.Controls.Add(txt)
                    Case "lbl"
                        Dim lbl As New Label
                        AddHandler lbl.DataBinding, AddressOf OnDataBinding
                        container.Controls.Add(lbl)
                End Select

        End Select

    End Sub

    Private Sub OnDataBinding(sender As Object, e As EventArgs)

        Dim txt As TextBox = DirectCast(sender, TextBox)
        Dim container As GridViewRow = DirectCast(sender.NamingContainer, GridViewRow)
        Dim dataValue As DateTime = DataBinder.Eval(container.DataItem, _colName)
        'sender.Text = dataValue.ToShortDateString()
        txt.Text = dataValue.ToShortDateString()
    End Sub

End Class