﻿Imports System.Data

Partial Class Controles_ControlRegistro
    Inherits System.Web.UI.UserControl
    Public iAnimalSeleccionado As New Integer
    Public sSexoanimal As String
    Public clases(9) As String



    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim Var As String



        Try
            If Not (Page.IsPostBack) Then
                iAnimalSeleccionado = Request.QueryString("animal")
                Dim sSexo As String = Request.QueryString("sexo")

                'Mostrar eliminar
                Dim sUsuario As String = String.Empty
                sUsuario = Membership.GetUser().UserName
                If (validaAccesosPantallas(sUsuario, sSexo)) Then
                End If

            End If
        Catch ex As Exception
            iAnimalSeleccionado = 0
            Response.Redirect("~/Registro/buscar.aspx")
        End Try


        Var = Request.QueryString("opt")
        Select Case Var
            Case "0"
                'clases(0) = "seleccion"
                linkBusqueda.Attributes.Add("class", "seleccion")
            Case "1"
                'clases(1) = "seleccion"
                linkGeneral.Attributes.Add("class", "seleccion")
            Case "2"
                'clases(2) = "seleccion"         
                linkMorfologia.Attributes.Add("class", "seleccion")
            Case "3"
                'clases(3) = "seleccion"
                linkGenealogia.Attributes.Add("class", "seleccion")
            Case "4"
                'clases(4) = "seleccion"
                linkCrias.Attributes.Add("class", "seleccion")
            Case "5"
                'clases(5) = "seleccion"
                linkTienta.Attributes.Add("class", "seleccion")
            Case "6"
                'clases(6) = "seleccion"
                linkLidia.Attributes.Add("class", "seleccion")
            Case "7"
                'clases(7) = "seleccion"
                linkSanidad.Attributes.Add("class", "seleccion")
            Case "8"
                'clases(8) = "seleccion"
                linkFotos.Attributes.Add("class", "seleccion")
            Case "9"
                'clases(9) = "seleccion"
                linkEliminar.Attributes.Add("class", "seleccion")
        End Select
    End Sub

    Public Function validaAccesosPantallas(ByVal sUsuario As String, ByVal sSexo As String) As Boolean
        linkBusqueda.Visible = False
        linkGeneral.Visible = False
        linkMorfologia.Visible = False
        linkGenealogia.Visible = False
        linkCrias.Visible = False
        linkTienta.Visible = False
        linkLidia.Visible = False
        linkSanidad.Visible = False
        linkFotos.Visible = False
        linkEliminar.Visible = False


        Dim sdsPantallas As New SqlDataSource
        Dim sSQL As String = "SELECT pantalla FROM dbo.Accesos WHERE UserName ='" & sUsuario & "';"
        Dim Resultado As Boolean = False
        Try
            sdsPantallas = New SqlDataSource
            sdsPantallas.ConnectionString = ConfigurationManager.ConnectionStrings("GanaderiaConnectionString").ConnectionString
            sdsPantallas.SelectCommand = sSQL


            Dim view As DataView = sdsPantallas.Select(New DataSourceSelectArguments())
            Dim groupsTable As DataTable = view.ToTable()

            For Each dr As DataRow In groupsTable.Rows
                If (Not Me.FindControl("link" & dr("pantalla").ToString.Trim) Is Nothing) Then
                    If (dr("pantalla").ToString.Trim.Equals("Lidia")) Then
                        Me.FindControl("link" & dr("pantalla").ToString.Trim).Visible = IIf(sSexo.Equals("T"), True, False)
                    Else
                        Me.FindControl("link" & dr("pantalla").ToString.Trim).Visible = True

                    End If
                End If
            Next


            linkBusqueda.HRef = "~/Registro/buscar.aspx?modulo=1"
            linkGeneral.HRef = "~/Registro/general.aspx?animal=" & iAnimalSeleccionado.ToString & "&sexo=" & sSexo & "&opt=1&modulo=1"
            linkMorfologia.HRef = "~/Registro/morfologia.aspx?animal=" & iAnimalSeleccionado.ToString & "&sexo=" & sSexo & "&opt=2&modulo=1"
            linkGenealogia.HRef = "~/Registro/genealogia.aspx?animal=" & iAnimalSeleccionado.ToString & "&sexo=" & sSexo & "&opt=3&modulo=1"
            linkCrias.HRef = "~/Registro/crias.aspx?animal=" & iAnimalSeleccionado.ToString & "&sexo=" & sSexo & "&opt=4&modulo=1"
            linkTienta.HRef = "~/Registro/tienta.aspx?animal=" & iAnimalSeleccionado.ToString & "&sexo=" & sSexo & "&opt=5&modulo=1"
            linkLidia.HRef = "~/Registro/lidia.aspx?animal=" & iAnimalSeleccionado.ToString & "&sexo=" & sSexo & "&opt=6&modulo=1"
            linkSanidad.HRef = "~/Registro/sanidad.aspx?animal=" & iAnimalSeleccionado.ToString & "&sexo=" & sSexo & "&opt=7&modulo=1"
            linkFotos.HRef = "~/Registro/fotos.aspx?animal=" & iAnimalSeleccionado.ToString & "&sexo=" & sSexo & "&opt=8&modulo=1"
            linkEliminar.HRef = "~/Registro/EliminarAnimal.aspx?animal=" & iAnimalSeleccionado.ToString & "&sexo=" & sSexo & "&opt=9&modulo=1"


            Return Resultado
        Catch ex As Exception
            Return False
        End Try
    End Function

End Class
